/*** Transations & database ***/

typedef vector<bool> Transaction; // of length NUM_ITEMS

typedef vector<Transaction> Db;


/*** Items & itemsets ***/

typedef int Item;

typedef struct
{
  map<Item> items,
  double support
} Itemset;

typedef map<Itemset, /* ordered by: */ Itemset.support> FreqItemsets;


/*** Prefix Tree nodes ***/

typedef struct
{
  Item firstChildIdx, // minimum possible first child
  vector<Node *> children // default Node* = NULL
} PTNode;


/*** Covering table entries ***/

typedef struct
{
  int num_uncovered,
  int transaction_id
} TransCover;

typedef map<TransCover, /* ordered by: */ TransCover.num_uncovered> TransCoverSet;


/*** Cartesian product & compressed db ***/

typedef struct
{
  vector<Itemset> itemset,
  vector<int> transaction_ids
} CartesianProduct;

typedef struct
{
  vector<CartesianProduct>
} CDb;
